/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.payroll.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.kintai.payroll.dto.KdPaidHolidayDto;

/**
 * KD_PAID_HOLIDAY(有休管理テーブル)のDAOクラス 。
 */
public class KdPaidHolidayDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * KD_PAID_HOLIDAY(有休管理テーブル)。
	 */
	public static final String	TABLE					= "KD_PAID_HOLIDAY";
	
	/**
	 * KEY_1 = PAID_ID(有休ID)。
	 */
	public static final String	KEY_1					= "PAID_ID";
	/**
	 * KEY_2 = K_CODE(社員コード)。
	 */
	public static final String	KEY_2					= "K_CODE";
	
	// 列名
	/**
	 * PAID_ID(有休ID)。
	 */
	public static final String	COL_PAID_ID				= "PAID_ID";
	/**
	 * K_CODE(社員コード)。
	 */
	public static final String	COL_K_CODE				= "K_CODE";
	/**
	 * PROCESS_TYPE(処理コード)。
	 */
	public static final String	COL_PROCESS_TYPE		= "PROCESS_TYPE";
	/**
	 * PROCESS_DATE(支給日)。
	 */
	public static final String	COL_PROCESS_DATE		= "PROCESS_DATE";
	/**
	 * LAST_REMAIN_DAYS(前年度残日数)。
	 */
	public static final String	COL_LAST_REMAIN_DAYS	= "LAST_REMAIN_DAYS";
	/**
	 * LAST_REMAIN_HOUR(前年度残時間)。
	 */
	public static final String	COL_LAST_REMAIN_HOUR	= "LAST_REMAIN_HOUR";
	/**
	 * REMAIN_DAYS(今年度残日数)。
	 */
	public static final String	COL_REMAIN_DAYS			= "REMAIN_DAYS";
	/**
	 * REMAIN_HOUR(今年度残時間)。
	 */
	public static final String	COL_REMAIN_HOUR			= "REMAIN_HOUR";
	/**
	 * POSSIBLE(時間単位取得可能日数)。
	 */
	public static final String	COL_POSSIBLE			= "POSSIBLE";
	/**
	 * DELETE_FLAG(削除フラグ)。
	 */
	public static final String	COL_DELETE_FLAG			= "DELETE_FLAG";
	

	/**
	 * コンストラクタ。
	 */
	public KdPaidHolidayDao() {
		super();
		INSERT_DATE = "INSERT_DATE";
		INSERT_USER = "INSERT_USER";
		UPDATE_DATE = "UPDATE_DATE";
		UPDATE_USER = "UPDATE_USER";
	}
	
	/**
	 * 検索結果取得(DTOのList)。
	 * @return 検索結果リスト
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private List<KdPaidHolidayDto> mappingAll() throws SQLException {
		List<KdPaidHolidayDto> all = new ArrayList<KdPaidHolidayDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)。
	 * @return KD_PAID_HOLIDAYレコード
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private KdPaidHolidayDto mapping() throws SQLException {
		KdPaidHolidayDto dto = new KdPaidHolidayDto();
		dto.setPaidId(rs.getLong(COL_PAID_ID));
		dto.setKCode(rs.getString(COL_K_CODE));
		dto.setProcessType(rs.getString(COL_PROCESS_TYPE));
		dto.setProcessDate(rs.getDate(COL_PROCESS_DATE));
		dto.setLastRemainDays(rs.getDouble(COL_LAST_REMAIN_DAYS));
		dto.setLastRemainHour(rs.getInt(COL_LAST_REMAIN_HOUR));
		dto.setRemainDays(rs.getDouble(COL_REMAIN_DAYS));
		dto.setRemainHour(rs.getInt(COL_REMAIN_HOUR));
		dto.setPossible(rs.getInt(COL_POSSIBLE));
		dto.setDeleteFlag(rs.getInt(COL_DELETE_FLAG));
		mappingCommonInfo(dto);
		return dto;
	}
	
	/**
	 * 全データ取得。
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<KdPaidHolidayDto> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得。
	 * @param paidId 有休ID
	 * @param kCode 社員コード
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public KdPaidHolidayDto findForKey(long paidId, String kCode) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, paidId);
			setParam(index++, kCode);
			executeQuery();
			KdPaidHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得。
	 * @param paidId 有休ID
	 * @param kCode 社員コード
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public KdPaidHolidayDto findForUpdate(long paidId, String kCode) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, paidId);
			setParam(index++, kCode);
			executeQuery();
			KdPaidHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param paidId 有休ID
	 * @param kCode 社員コード
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<KdPaidHolidayDto> findForCondition(long paidId, String kCode) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_PAID_ID);
		sb.append(" = ? AND ");
		sb.append(COL_K_CODE);
		sb.append(" = ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, paidId);
			setParam(index++, kCode);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param processType 対象処理コード
	 * @param startDate 開始年月日
	 * @param endDate 終了年月日
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<KdPaidHolidayDto> findForCondition(String kCode, String processType, Date startDate, Date endDate)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_DELETE_FLAG);
		sb.append(" = " + MospConst.DELETE_FLAG_OFF);
		sb.append(" AND ");
		sb.append(COL_K_CODE);
		sb.append(" = ? AND ");
		sb.append(COL_PROCESS_TYPE);
		sb.append(" = ? ");
		sb.append(" AND ");
		sb.append(COL_PROCESS_DATE);
		sb.append(" >= ? ");
		sb.append(" AND ");
		sb.append(COL_PROCESS_DATE);
		sb.append(" <= ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, kCode);
			setParam(index++, processType);
			setParam(index++, startDate);
			setParam(index++, endDate);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param startDate 開始年月日
	 * @param endDate 終了年月日
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<KdPaidHolidayDto> findForCondition(String kCode, Date startDate, Date endDate) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_K_CODE);
		sb.append(" = ? AND ");
		sb.append(COL_PROCESS_DATE);
		sb.append(" >= ? ");
		sb.append(" AND ");
		sb.append(COL_PROCESS_DATE);
		sb.append(" <= ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, kCode);
			setParam(index++, startDate);
			setParam(index++, endDate);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param processType 対象処理コード
	 * @param processDate 対象年月日
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public KdPaidHolidayDto findForProcess(String kCode, String processType, Date processDate) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = " + MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_K_CODE);
			sb.append(" = ? AND ");
			sb.append(COL_PROCESS_TYPE);
			sb.append(" = ? AND ");
			sb.append(COL_PROCESS_DATE);
			sb.append(" = ? ");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, kCode);
			setParam(index++, processType);
			setParam(index++, processDate);
			executeQuery();
			KdPaidHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param kCode 社員コード
	 * @param processType 対象処理コード
	 * @param processDate 対象年月日
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public KdPaidHolidayDto findForProcessNearlyDate(String kCode, String processType, Date processDate)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = " + MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_K_CODE);
			sb.append(" = ? AND ");
			sb.append(COL_PROCESS_TYPE);
			sb.append(" = ? AND ");
			sb.append(COL_PROCESS_DATE);
			sb.append(" <= ? ");
			sb.append(getOrderBy());
			sb.append(COL_PROCESS_DATE);
			sb.append(" ");
			sb.append(getDesc());
			sb.append(getLimit());
			sb.append("1");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, kCode);
			setParam(index++, processType);
			setParam(index++, processDate);
			executeQuery();
			KdPaidHolidayDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * max値取得
	 * @param kCode 対象社員コード
	 * @return String　最大連番
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public String findForMax(String kCode) throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			String maxPaidId = "";
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("SELECT MAX(");
			sb.append(COL_PAID_ID);
			sb.append(") FROM ");
			sb.append(TABLE);
			sb.append(" WHERE ");
			sb.append(COL_K_CODE);
			sb.append(" = ? ");
			prepareStatement(sb.toString());
			setParam(index++, kCode);
			executeQuery();
			if (rs.next()) {
				maxPaidId = String.valueOf(rs.getInt(1));
			}
			return maxPaidId;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入。
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(KdPaidHolidayDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * @param list		新有給休暇情報
	 * @param divSize	件数
	 * @return	挿入結果(件数)
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(List<KdPaidHolidayDto> list, int divSize) throws SQLException, IllegalAccessException,
			NoSuchFieldException, MospException {
		try {
			index = 1;
			int listSize = list.size();
			int rev = listSize / divSize + 1;
			if (listSize % divSize == 0) {
				rev--;
			}
			int insertCount = 0;
			List<KdPaidHolidayDto> divList = new ArrayList<KdPaidHolidayDto>();
			for (int i = 0; i < rev; i++) {
				// リストをdiv件ごと分割する。
				for (int k = 0; k < divSize; k++) {
					int count = k + (i * divSize);
					if (count >= listSize) {
						break;
					}
					divList.add(list.get(count));
				}
				int divListSize = divList.size();
				prepareStatement(getInsertQuery(getClass(), divListSize, divSize));
				for (KdPaidHolidayDto dto : divList) {
					setParams(dto, true);
				}
				executeUpdate();
				clearParams();
				index = 1;
				divList.clear();
				chkInsert(divListSize);
				insertCount += cnt;
			}
			return insertCount;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新。
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int update(KdPaidHolidayDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getPaidId());
			setParam(index++, dto.getKCode());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除。
	 * @param dto 更新対象DTO
	 * @return int 削除結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int delete(KdPaidHolidayDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getDeleteQuery(getClass()));
			setParam(index++, dto.getPaidId());
			setParam(index++, dto.getKCode());
			executeUpdate();
			chkDelete(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定。
	 * @param dto 更新対象DTO
	 * @param isInsert 挿入文フラグ(true：挿入文、false：挿入文)
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private void setParams(KdPaidHolidayDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getPaidId());
		setParam(index++, dto.getKCode());
		setParam(index++, dto.getProcessType());
		setParam(index++, dto.getProcessDate());
		setParam(index++, dto.getLastRemainDays());
		setParam(index++, dto.getLastRemainHour());
		setParam(index++, dto.getRemainDays());
		setParam(index++, dto.getRemainHour());
		setParam(index++, dto.getPossible());
		setParam(index++, dto.getDeleteFlag());
		setCommonParams(isInsert);
	}
	
}
